ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.2 by root, Wed Mar 7 01:23:37 2007 UTC vs.
Revision 1.77 by root, Tue Nov 3 23:44:21 2009 UTC

1#!@PERL@ 1#!@PERL@
2
3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
2 24
3use strict; 25use strict;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
34my $OPTIPNG = "@OPTIPNG@";
12my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
13 37
14use Getopt::Long; 38use Getopt::Long;
15use IO::AIO;
16use File::Temp; 39use File::Temp;
17use Crossfire; 40use POSIX ();
41use Carp;
42
43use Coro::EV;
44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
47use IO::AIO ();
48
49use Coro 5.12;
50use Coro::AIO;
51use Coro::Util;
52use Coro::Channel;
53use Coro::Storable; $Storable::canonical = 1;
54
55use Deliantra;
56
57$SIG{QUIT} = sub { Carp::cluck "QUIT" };
18 58
19sub usage { 59sub usage {
20 warn <<EOF; 60 warn <<EOF;
21Usage: cfutil [-v] [-q] [--force] 61Usage: cfutil [-v] [-q] [--force] [--cache]
22 [--install-arch path] 62 [--install-arch path]
23 [--install-maps maps] 63 [--install-maps maps]
24 [--print-statedir] 64 [--print-statedir]
25 [--print-confdir] 65 [--print-confdir]
26 [--print-datadir] 66 [--print-datadir]
29EOF 69EOF
30 exit 1; 70 exit 1;
31} 71}
32 72
33my $VERBOSE = 1; 73my $VERBOSE = 1;
74my $CACHE = 0;
34my $FORCE; 75my $FORCE;
35my $TMPDIR = "/tmp/cfutil$$~"; 76my $TMPDIR = "/tmp/cfutil$$~";
77my $TMPFILE = "aaaa0";
78
79our %COLOR = (
80 black => 0,
81 white => 1,
82 navy => 2,
83 red => 3,
84 orange => 4,
85 blue => 5,
86 darkorange => 6,
87 green => 7,
88 lightgreen => 8,
89 grey => 9,
90 brown => 10,
91 gold => 11,
92 tan => 12,
93);
36 94
37END { system "rm", "-rf", $TMPDIR } 95END { system "rm", "-rf", $TMPDIR }
96
97my $s_INT = EV::signal INT => sub { exit 1 };
98my $s_TERM = EV::signal TERM => sub { exit 1 };
38 99
39mkdir $TMPDIR, 0700 100mkdir $TMPDIR, 0700
40 or die "$TMPDIR: $!"; 101 or die "$TMPDIR: $!";
41 102
103sub fork_sub(&) {
104 my ($cb) = @_;
105
106 if (my $pid = fork) {
107 my $current = $Coro::current;
108 my $w = AnyEvent->child (pid => $pid, cb => sub { $current->ready });
109 Coro::schedule;
110 } else {
111 eval { $cb->() };
112 POSIX::_exit 0 unless $@;
113 warn $@;
114 POSIX::_exit 1;
115 }
116}
117
42sub inst_maps($) { 118sub inst_maps($) {
43 my (undef, $path) = @_; 119 my (undef, $path) = @_;
44 120
45 print "installing '$path' to '$DATADIR/maps'\n\n"; 121 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
46 122
47 if (!-f "$path/regions") { 123 if (!-f "$path/regions") {
48 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 124 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
49 exit 1 unless $FORCE; 125 exit 1 unless $FORCE;
50 } 126 }
51 127
52 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 128 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
129 "$path/.", "$DATADIR/maps/.",
130 "--exclude", "CVS", "--exclude", "/world-precomposed",
131 "--delete", "--delete-excluded"
132 and die "map installation failed.\n";
133
134 print "maps installed successfully.\n";
53} 135}
54 136
55{ 137{
56 my @PNG; 138 our %ANIMINFO;
139 our %FACEINFO;
140 our %RESOURCE;
57 my @ARC; 141 our @ARC;
142 our %ARC;
143 our $TRS;
144 our $NFILE;
145 our $PATH;
58 146
147 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
148
149 our $c_arc = new Coro::Channel;
150 our $c_trs = new Coro::Channel;
151 our $c_res = new Coro::Channel;
152
153 our @c_png;
154
59 sub commit_png { 155 sub commit_png($$$) {
60 my ($name, $data) = @_; 156 my ($name, $data, $T) = @_;
61 #warn "$name: commited\n";
62 }
63 157
64 sub add_png($) { 158 $FACEINFO{$name}{"data$T"} = $data;
159 }
160
161 sub process_png {
162 while (@c_png) {
163 my ($path, $delete) = @{pop @c_png};
164
165 my $png;
166 aio_lstat $path;
167 my ($size, $mtime) = (stat _)[7,9];
168
169 if (0 > aio_load $path, $png) {
170 warn "$path: $!, skipping.\n";
171 next;
172 }
173
174 my $stem = $path;
175 my $T;
176
177 if ($stem =~ s/\.32x32\.png~?$//) {
178 $T = 32;
179 } elsif ($stem =~ s/\.64x64\.png~?$//) {
180 $T = 64;
181 } else {
182 warn "$path: weird filename, skipping.\n";
183 next;
184 }
185
186 # quickly extract width and height of the (necessarily PNG) image
187 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
188 warn "$path: not a recognized png file, skipping.\n";
189 next;
190 }
191
192 my ($w, $h) = unpack "NN", $1;
193
194 if ($w < $T || $h < $T) {
195 warn "$path: too small ($w $h), skipping.\n";
196 next;
197 }
198
199 if ($w % $T || $h % $T) {
200 warn "$path: weird png size ($w $h), skipping.\n";
201 next;
202 }
203
204 (my $base = $stem) =~ s/^.*\///;
205
206 my $fi = $FACEINFO{$base};
207 unless ($fi) {
208 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
209 #next;
210 }
211
212 my $arc = $fi->{arc} || { };
213
214 unless ($path =~ /~$/) {
215 # possibly enlarge
216 if (0 > aio_stat "$stem.64x64.png") {
217 my $other = "$stem.64x64.png~";
218
219 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
220 fork_sub {
221 my $CROP;
222 my $SRC = "png:\Q$path\E";
223
224 my $is_floor = $arc->{is_floor};
225 my $is_wall = 0;
226
227 my ($wall_pfx, $wall_dir, $wall_sfx);
228
229 if (
230 !$is_floor
231 && !$arc->{alive}
232 && $arc->{move_block} eq "all"
233 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
234 ) {
235 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
236
237 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
238 $is_wall = 1;
239 }
240 }
241
242 if ($is_wall || $is_floor) {
243 # add a 4px border and add other images around it
244 $CROP = "-shave 8x8 +repage";
245
246 $w += 8;
247 $h += 8;
248
249 $SRC = "-size ${w}x${h} xc:transparent";
250 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
251
252 # 8 surrounding images
253 for (
254 # x y b r0 r1
255 [-1, -1, 0, 6],
256 [ 0, -1, 1, 10, 14],
257 [+1, -1, 0, 12],
258
259 [-1, 0, 8, 5, 7],
260 #
261 [+1, 0, 2, 5, 13],
262
263 [-1, +1, 0, 3],
264 [ 0, +1, 4, 10, 11],
265 [+1, +1, 0, 9],
266 ) {
267 my ($x, $y, $d, $r0, $r1) = @$_;
268
269 my $tile = $is_floor ? $path
270 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
271 : die;
272
273 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
274 "\Q$tile",
275 $x * ($w - 8) + 4,
276 $y * ($h - 8) + 4;
277 }
278 }
279
280 system "convert -depth 8 $SRC rgba:-"
281 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
282 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
283 and die "convert/cfhq2xa pipeline error: status $? ($!)";
284 system $OPTIPNG, "-i0", "-q", "$other~";
285 die "$other~ has zero size, aborting." unless -s "$other~";
286 rename "$other~", $other;
287 };
288 }
289
290 push @c_png, [$other, !$CACHE];
291 }
292
293 # possibly scale down
294 if (0 > aio_stat "$stem.32x32.png") {
295 my $other = "$stem.32x32.png~";
296
297 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
298 fork_sub {
299 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
300 system $OPTIPNG, "-i0", "-q", "$other~";
301
302 # reduce smoothfaces >10000 bytes
303 # obsolete, no longer required
304 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
305 my $ncolor = 256;
306 while () {
307 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
308 system $OPTIPNG, "-i0", "-q", "$other~~";
309 last if 10000 > -s "$other~~";
310 $ncolor = int $ncolor * 0.9;
311 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
312 }
313
314 printf "reduced %s from %d to %d bytes using %d colours.\n",
315 $other, -s "$other~", -s "$other~~", $ncolor
316 if $VERBOSE >= 2;
317 rename "$other~~", "$other~";
318 }
319
320 die "$other~ has zero size, aborting." unless -s "$other~";
321 rename "$other~", $other;
322 };
323 }
324
325 #warn "scaled down $path to $other\n";#d#
326 push @c_png, [$other, !$CACHE];
327 }
328 }
329
330 (my $face = $stem) =~ s/^.*\///;
331
332 # split all bigfaces, but avoid smoothfaces (*_S)
333 if (($w > $T || $h > $T) && $face !~ /_S\./) {
334 # split
335 my @tile;
336 for my $x (0 .. (int $w / $T) - 1) {
337 for my $y (0 .. (int $h / $T) - 1) {
338 my $file = "$path+$x+$y~";
339 aio_lstat $file;
340 push @tile, [$x, $y, $file, (stat _)[9]];
341 }
342 }
343
344 my $mtime = (lstat $path)[9];
345 my @todo = grep { $_->[3] <= $mtime } @tile;
346 if (@todo) {
347 fork_sub {
348 open my $convert, "|-", $CONVERT,
349 "png:-",
350 (map {
351 (
352 "(",
353 "+clone",
354 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
355 "+repage",
356 -quality => "00",
357 -write => "png32:$_->[2]~",
358 "+delete",
359 ")",
360 )
361 } @todo),
362 "null:";
363
364 binmode $convert;
365 print $convert $png;
366 close $convert;
367
368 # pass 2, optimise, and rename
369 for (@todo) {
370 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
371 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
372 rename "$_->[2]~", $_->[2];
373 }
374 };
375 }
376
377 for (@tile) {
378 my ($x, $y, $file) = @$_;
379 my $tile;
380
381 if (0 > aio_load $file, $tile) {
382 die "$path: unable to read tile +$x+$y, aborting.\n";
383 }
384 IO::AIO::aio_unlink $file unless $CACHE;
385 commit_png $x|$y ? "$face+$x+$y" : $face, $tile, $T;
386 }
387 } else {
388 # use as-is (either small, use smooth)
389 commit_png $face, $png, $T;
390 }
391
392 aio_unlink $path if $delete;
393 }
394 }
395
396 sub process_arc {
397 while (my $job = $c_arc->get) {
398 my ($dir, $file) = @$job;
399
400 my $arc;
401 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
402
403 my $arc = read_arch "$dir/$file";
404 for my $o (values %$arc) {
405 push @ARC, $o;
406 for (my $m = $o; $m; $m = $m->{more}) {
407 $ARC{$m->{_name}} = $m;
408 }
409
410 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
411
412 my $visibility = delete $o->{visibility};
413 my $magicmap = delete $o->{magicmap};
414
415 # find upper left corner :/
416 # omg, this is sooo broken
417 my ($dx, $dy);
418 for (my $o = $o; $o; $o = $o->{more}) {
419 $dx = $o->{x} if $o->{x} < $dx;
420 $dy = $o->{y} if $o->{y} < $dy;
421 }
422
423 for (my $o = $o; $o; $o = $o->{more}) {
424 my $x = $o->{x} - $dx;
425 my $y = $o->{y} - $dy;
426
427 my $ext = $x|$y ? "+$x+$y" : "";
428
429 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
430
431 $visibility = delete $o->{visibility} if exists $o->{visibility};
432 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
433
434 my $anim = delete $o->{anim};
435
436 if ($anim) {
437 # possibly add $ext to the animation name to avoid
438 # the need to specify archnames for all parts
439 # of a multipart archetype.
440 $o->{animation} = "$o->{_name}";
441 my $facings = 1;
442 my @frames;
443
444 for (@$anim) {
445 if (/^facings\s+(\d+)/) {
446 $facings = $1*1;
447 } elsif (/^blank.x11$|^empty.x11$/) {
448 push @frames, $_;
449 } else {
450 push @frames, "$_$ext";
451 }
452 }
453
454 $ANIMINFO{$o->{animation}} = {
455 facings => $facings,
456 frames => \@frames,
457 };
458 }
459
460 for ($o->{face} || (), @{$anim || []}) {
461 next if /^facings\s/;
462
463 my $face = $_;
464 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
465
466 my $info = $FACEINFO{$face} ||= { };
467 $info->{arc} = $o;
468
469 next if $face =~ /^blank.x11$|^empty.x11$/;
470
471 $info->{visibility} = $visibility if defined $visibility;
472 $info->{magicmap} = $magicmap if defined $magicmap;
473 }
474
475 if (my $smooth = delete $o->{smoothface}) {
476 my %kv = split /\s+/, $smooth;
477 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
478 while (my ($face, $smooth) = each %kv) {
479 $FACEINFO{$smooth}{arc} = $o;
480
481 $FACEINFO{$face}{smooth} = $smooth;
482 $FACEINFO{$face}{smoothlevel} = $level;
483 }
484 }
485 }
486 }
487 }
488 }
489
490 sub process_trs {
491 while (my $job = $c_trs->get) {
492 my ($dir, $file) = @$job;
493 my $path = "$dir/$file";
494
495 my $trs;
496 if (0 > aio_load $path, $trs) {
497 warn "$path: $!, skipping.\n";
498 next;
499 }
500
501 $TRS .= $trs;
502 }
503 }
504
505 my %FILECACHE;
506
507 sub load_cached($;$) {
508 unless (exists $FILECACHE{$_[0]}) {
509 my $data;
510 if (0 < aio_load $_[0], $data) {
511 if ($_[1]) {
512 $data = eval { $_[1]->($data) };
513 warn "$_[0]: $@" if $@;
514 }
515 }
516
517 $FILECACHE{$_[0]} = $data;
518 }
519
520 $FILECACHE{$_[0]}
521 }
522
523 sub process_res {
524 while (my $job = $c_res->get) {
525 my ($dir, $file, $type) = @$job;
526
527 my $data;
528 aio_load "$dir/$file", $data;
529
530 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
531
532 utf8::decode $dir;
533 utf8::decode $file;
534
535 # a meta file for resources is now mandatory
536 unless (exists $meta->{$file}) {
537 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
538 next;
539 }
540
541 $meta = {
542 %{ $meta->{"" } || {} },
543 %{ $meta->{$file} || {} },
544 };
545
546 if ($meta->{license} =~ s/^#//) {
547 $meta->{license} = ({
548 "pd" => "Public Domain",
549 "gpl" => "GNU General Public License, version 3.0 or any later",
550 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
551 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
552 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
553 })->{$meta->{license}}
554 || warn "$dir/$file: license tag '$meta->{license}' not found.";
555 }
556
557 $file =~ s/\.res$//;
558 $file =~ s/\.(ogg|wav|jpg|png)$//;
559
560 substr $dir, 0, 1 + length $PATH, "";
561
562 if (my $filter = $meta->{cfutil_filter}) {
563 if ($filter eq "yaml2json") {
564 $data = JSON::XS::encode_json YAML::XS::Load $data;
565 } elsif ($filter eq "json2json") {
566 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
567 } elsif ($filter eq "perl2json") {
568 $data = eval $data; die if $@;
569 $data = JSON::XS::encode_json $data;
570 } else {
571 warn "$dir/$file: unknown filter $filter, skipping\n";
572 }
573 }
574
575 $RESOURCE{"$dir/$file"} = {
576 type => (exists $meta->{type} ? delete $meta->{type} : $type),
577 data => $data,
578 %$meta ? (meta => $meta) : (),
579 };
580 }
581 }
582
583 sub find_files;
584 sub find_files {
65 my ($path) = @_; 585 my ($path) = @_;
66 586
67 my $png; 587 IO::AIO::aioreq_pri 4;
68 aio_lstat $path, sub { 588 IO::AIO::aio_scandir $path, 4, sub {
69 my ($size, $mtime) = (stat _)[7,9]; 589 my ($dirs, $nondirs) = @_;
70 590
71 aio_load $path, $png, sub { 591 find_files "$path/$_"
72 if ($_[0] < 0) { 592 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
73 warn "$path: $!, skipping.\n"; 593
74 return; 594 my $dir = $path;
595 substr $dir, 0, 1 + length $PATH, "";
596
597 for my $file (@$nondirs) {
598 if ($dir =~ /^music(?:\/|$)/) {
599 $c_res->put ([$path, $file, 3]) # FT_MUSIC
600 if $file =~ /\.(ogg)$/;
601
602 } elsif ($dir =~ /^sound(?:\/|$)/) {
603 $c_res->put ([$path, $file, 5]) # FT_SOUND
604 if $file =~ /\.(wav|ogg)$/;
605
606 } elsif ($dir =~ /^res(?:\/|$)/) {
607 if ($file =~ /\.(jpg|png)$/) {
608 $c_res->put ([$path, $file, 0]) # FT_FACE
609 } elsif ($file =~ /\.(res)$/) {
610 $c_res->put ([$path, $file, 6]) # FT_RSRC
611 } else {
612 $c_res->put ([$path, $file, undef]);
75 } 613 }
76 614
77 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 615 } elsif ($file =~ /\.png$/) {
78 warn "$path: not a recongized png file, skipping.\n"; 616 push @c_png, ["$path/$file", 0];
79 return;
80 }
81 617
82 my ($w, $h) = unpack "NN", $1; 618 } elsif ($file =~ /\.trs$/) {
619 $c_trs->put ([$path, $file]);
83 620
84 (my $face = $path) =~ s/^.*\///; 621 } elsif ($file =~ /\.arc$/) {
85 my $T = 32; 622 $c_arc->put ([$path, $file]);
86 623
87 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
88 warn "$path: weird filename, skipping.\n";
89 return;
90 }
91
92 if ($w < $T || $h < $T) {
93 warn "$path: too small ($w $h), skipping.\n";
94 return;
95 }
96
97 if ($w % $T || $h % $T) {
98 warn "$path: weird png size ($w $h), skipping.\n";
99 return;
100 }
101
102 if ($w > $T || $h > $T) {
103 # split
104 } else { 624 } else {
105 # use as-is 625 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
106 commit_png $face, $png;
107 } 626 }
108
109 #warn "$path: $w, $h\n";
110 }; 627 }
111 }; 628 };
112
113 IO::AIO::poll; # reduce file-handle pressure
114 } 629 }
115 630
116 sub add_arc($$) { 631 sub generate_plurals {
117 my ($dir, $file) = @_; 632# use Lingua::EN::Inflect ();
118 633# Lingua::EN::Inflect::classical;
119 my $arc; 634# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
120 aio_load "$dir/$file", $arc, sub { # simply pre-cache, as read_arch wants a file :/ 635# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
121 my $arc = read_arch "$dir/$file"; 636#
122 }; 637# for my $a (@ARC) {
123 } 638# my $name = $a->{name} || $a->{_name};
124 639#
125 sub add_trs($$) { 640# next unless $a->{name_pl};
126 my ($dir, $file) = @_; 641# next if $a->{invisible};
127 } 642# next if $a->{is_floor};
128 643# next if $a->{no_pick};
129 sub collect_arch; 644#
130 sub collect_arch { 645# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
131 my ($path) = @_; 646# my $pl = $test =~ /^(?:eq|p:.)$/
132 647# ? $name
133 aioreq_pri 4; 648# : Lingua::EN::Inflect::PL $name;
134 aio_scandir $path, 4, sub { 649#
135 my ($dirs, $nondirs) = @_; 650# if ($pl ne $a->{name_pl}) {
136 651# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
137 collect_arch "$path/$_"
138 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
139
140 for my $file (@$nondirs) {
141 if ($file =~ /\.png$/) {
142 add_png "$path/$file";
143 } elsif ($file =~ /\.trs$/) {
144 add_trs $path, $file;
145 } elsif ($file =~ /\.arc$/) {
146 add_arc $path, $file;
147 } else {
148 warn "ignoring $path/$file\n" if $VERBOSE >= 2;
149 }
150 } 652# }
151 }; 653# }
152 } 654 }
153 655
154 sub inst_arch($) { 656 sub inst_arch($) {
155 my (undef, $path) = @_; 657 my (undef, $path) = @_;
156 658
659 $PATH = $path;
660
661 print "\n",
157 print "installing '$path' to '$DATADIR'\n\n"; 662 "Installing '$path' to '$DATADIR'\n",
663 "\n",
664 "This can take a long time if you run this\n",
665 "for the first time or do not use --cache.\n",
666 "\n",
667 "Unless you run verbosely, all following warning\n",
668 "or error messages indicate serious problems.\n",
669 "\n";
158 670
159 if (!-d "$path/treasures") { 671 if (!-d "$path/treasures") {
160 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 672 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
161 exit 1 unless $FORCE; 673 exit 1 unless $FORCE;
162 } 674 }
163 675
164 collect_arch $path; 676 print "scanning files...\n" if $VERBOSE;
677
678 find_files $path;
679
680 my @a_arc = map +(async \&process_arc), 1..2;
681 my @a_res = map +(async \&process_res), 1..2;
682 my @a_trs = map +(async \&process_trs), 1..2;
683
165 IO::AIO::flush; 684 IO::AIO::flush;
166 685
167 die "--install-arch not yet implemented\n"; 686 $c_res->shutdown;
687 $c_arc->shutdown;
688 $c_trs->shutdown;
689
690 print "start file scan, arc, res processing...\n" if $VERBOSE;
691
692 $_->join for @a_arc; # need to parse all archetypes before png processing
693
694 print "end arc, start png processing...\n" if $VERBOSE;
695
696 # eight png crunchers work fine for my 4x smp machine
697 my @a_png = map +(async \&process_png), 1..8;
698
699 $_->join for (@a_trs, @a_res, @a_png);
700
701 print "scanning done, processing results...\n" if $VERBOSE;
702 {
703 # remove path prefix from editor_folder
704 $_->{editor_folder} =~ /^\x00/
705 and substr $_->{editor_folder}, 0, 2 + length $path, ""
706 for values %ARC;
707
708 print "resolving inheritance tree...\n" if $VERBOSE;
709 # resolve inherit
710 while () {
711 my $progress;
712 my $loop;
713
714 for my $o (values %ARC) {
715 if (my $other = $o->{inherit}) {
716 if (my $s = $ARC{$other}) {
717 if ($s->{inherit}) {
718 $loop = $s;
719 } else {
720 delete $o->{inherit};
721 my %s = %$s;
722 delete @s{qw(_name more name name_pl)};
723 %$o = ( %s, %$o );
724 ++$progress;
725 }
726 } else {
727 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
728 delete $ARC{$o->{_name}};
729 }
730 }
731 }
732
733 unless ($progress) {
734 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
735 if $loop;
736
737 last;
738 }
739 }
740
741 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
742 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
743
744 print "generating plurals...\n" if $VERBOSE;
745 generate_plurals;
746
747 print "writing archetypes...\n" if $VERBOSE;
748 open my $fh, ">:utf8", "$DATADIR/archetypes~"
749 or die "$DATADIR/archetypes~: $!";
750 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
751 }
752
753 {
754 print "writing treasures...\n" if $VERBOSE;
755 open my $fh, ">:utf8", "$DATADIR/treasures~"
756 or die "$DATADIR/treasures~: $!";
757 print $fh $TRS;
758 }
759
760 {
761 print "processing facedata...\n" if $VERBOSE;
762 while (my ($k, $v) = each %FACEINFO) {
763 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
764 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
765
766 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
767 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
768
769 if (my $magicmap = $v->{magicmap}) {
770 $magicmap =~ y/A-Z_\-/a-z/d;
771 $v->{magicmap} = $COLOR{$magicmap};
772 }
773
774 delete $v->{arc};
775 }
776
777 print "writing facedata...\n" if $VERBOSE;
778 open my $fh, ">:perlio", "$DATADIR/facedata~"
779 or die "$DATADIR/facedata~: $!";
780
781 print $fh freeze {
782 version => 2,
783 faceinfo => \%FACEINFO,
784 animinfo => \%ANIMINFO,
785 resource => \%RESOURCE,
786 };
787 }
788
789 print "committing files...\n" if $VERBOSE;
790
791 for (qw(archetypes facedata treasures)) {
792 chmod 0644, "$DATADIR/$_~";
793 rename "$DATADIR/$_~", "$DATADIR/$_"
794 or die "$DATADIR/$_: $!";
795 }
796
797 print "archetype data installed successfully.\n";
168 } 798 }
169} 799}
170 800
171Getopt::Long::Configure ("bundling", "no_ignore_case"); 801Getopt::Long::Configure ("bundling", "no_ignore_case");
172GetOptions ( 802GetOptions (
173 "verbose|v:+" => \$VERBOSE, 803 "verbose|v:+" => \$VERBOSE,
804 "cache" => \$CACHE,
174 "quiet|q" => sub { $VERBOSE = 0 }, 805 "quiet|q" => sub { $VERBOSE = 0 },
175 "force" => sub { $FORCE = 1 }, 806 "force" => sub { $FORCE = 1 },
176 "install-arch=s" => \&inst_arch, 807 "install-arch=s" => \&inst_arch,
177 "install-maps=s" => \&inst_maps, 808 "install-maps=s" => \&inst_maps,
178 "print-statedir" => sub { print "@pkgstatedir@\n" }, 809 "print-statedir" => sub { print "@pkgstatedir@\n" },

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines